searchNodes=[{"doc":"A set of tools for convenient work with RabbitMQ. Based on AMQP elixir client. Includes: RMQ.Connection - a behaviour for implementing managing of RabbitMQ connection. RMQ.Consumer - a behaviour for implementing RabbitMQ consumer. RMQ.RPC - a behaviour for implementing RPC via RabbitMQ.","ref":"RMQ.html","title":"RMQ","type":"module"},{"doc":"A connection module","ref":"RMQ.Conn.html","title":"RMQ.Conn","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"RMQ.Conn.html#child_spec/1","title":"RMQ.Conn.child_spec/1","type":"function"},{"doc":"","ref":"RMQ.Conn.html#c:config/0","title":"RMQ.Conn.config/0","type":"callback"},{"doc":"","ref":"RMQ.Conn.html#c:get/0","title":"RMQ.Conn.get/0","type":"callback"},{"doc":"","ref":"RMQ.Conn.html#c:init/2","title":"RMQ.Conn.init/2","type":"callback"},{"doc":"","ref":"RMQ.Conn.html#c:start_link/1","title":"RMQ.Conn.start_link/1","type":"callback"},{"doc":"","ref":"RMQ.Conn.html#start_link/2","title":"RMQ.Conn.start_link/2","type":"function"},{"doc":"A GenServer which provides a robust connection to RabbitMQ broker. Can be used as following: defmodule MyApp.RabbitConnection do use RMQ.Connection, otp_app: :my_app, uri: &quot;amqp://localhost&quot;, connection_name: to_string(__MODULE__) end Can be configured via the application environment: config :my_app, MyApp.RabbitConnection, uri: &quot;amqp://localhost&quot;, connection_name: &quot;MyApp.RabbitConnection&quot; Supports dynamic configuration via config/0 callback: defmodule MyApp.RabbitConnection do use RMQ.Connection, otp_app: :my_app def config do [ uri: System.get_env(&quot;RABBIT_URL&quot;, &quot;amqp://localhost&quot;), connection_name: to_string(__MODULE__) ] end end Configuration :otp_app - the only required value. It should point to an OTP application that has the connection configuration. :uri - AMQP URI. Defaults to &quot;amqp://localhost&quot;; :connection_name - RabbitMQ connection name. Defaults to :undefined; :reconnect_interval - reconnect interval. Defaults to 5000; options for AMQP.Connection.open/3.","ref":"RMQ.Connection.html","title":"RMQ.Connection","type":"behaviour"},{"doc":"Callback for dynamic configuration. Can be used in case the connection configuration needs to be set dynamically, for example by reading a system environment variable.","ref":"RMQ.Connection.html#c:config/0","title":"RMQ.Connection.config/0","type":"callback"},{"doc":"Gets the connection.","ref":"RMQ.Connection.html#c:get_connection/0","title":"RMQ.Connection.get_connection/0","type":"callback"},{"doc":"Starts a GenServer process linked to the current process.","ref":"RMQ.Connection.html#c:start_link/1","title":"RMQ.Connection.start_link/1","type":"callback"},{"doc":"RabbitMQ Consumer. Keep in mind that the consumed message needs to be explicitly acknowledged via AMQP.Basic.ack/3 or rejected via AMQP.Basic.reject/3. For convenience, these functions are imported and are available directly. AMQP.Basic.publish/3 is imported as well which is convenient for the case when the consumer implements RPC. Configuration :connection - the connection module which implements RMQ.Connection behaviour; :queue - the name of the queue to consume. Will be created if does not exist; :exchange - the name of the exchange to which queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;&quot;; :routing_key - queue binding key. Defaults to queue; Will be created if does not exist. Defaults to &quot;&quot;; :dead_letter - defines if the consumer should setup deadletter exchange and queue. Defaults to true; :dead_letter_queue - the name of dead letter queue. Defaults to &quot;\#{queue}_error&quot;; :dead_letter_exchange - the name of the exchange to which dead_letter_queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;\#{exchange}.dead-letter&quot;; :dead_letter_routing_key - routing key for dead letter messages. Defaults to queue; :concurrency - defines if consume/3 callback will be called in a separate process. Defaults to true; :prefetch_count - sets the message prefetch count. Defaults to 10; :consumer_tag - consumer tag. Defaults to a current module name; :restart_delay - restart delay. Defaults to 5000. Example defmodule MyApp.Consumer do use RMQ.Consumer, connection: MyApp.RabbitConnection, queue: &quot;my-app-consumer-queue&quot; @impl RMQ.Consumer def process(message, %{content_type: &quot;application/json&quot;}), do: Jason.decode!(message) def process(message, _meta), do: message @impl RMQ.Consumer def consume(chan, payload, meta) do # handle message here ack(chan, meta.delivery_tag) end end","ref":"RMQ.Consumer.html","title":"RMQ.Consumer","type":"behaviour"},{"doc":"Consumes the message.","ref":"RMQ.Consumer.html#c:consume/3","title":"RMQ.Consumer.consume/3","type":"callback"},{"doc":"Optional callback for processing the message before consuming it. Accepts payload and metadata. Must return (modified) payload.","ref":"RMQ.Consumer.html#c:process/2","title":"RMQ.Consumer.process/2","type":"callback"},{"doc":"Starts a GenServer process linked to the current process.","ref":"RMQ.Consumer.html#c:start_link/1","title":"RMQ.Consumer.start_link/1","type":"callback"},{"doc":"RPC via RabbitMQ. In short, it&#39;s a GenServer which Implements a publisher and a consumer in one place. A module which will implement this behaviour will be able to publish messages via call/4 and wait for a response. You can read more about how this works in the tutorial. Configuration :connection - the connection module which implements RMQ.Connection behaviour; :exchange - the name of the exchange to which RPC consuming queue is bound. Please make sure the exchange exist. Defaults to &quot;&quot;. :timeout - default timeout for call/4. Will be passed directly to the underlying call of GenServer.call/3 Defaults to 5000. :consumer_tag - consumer tag for the callback queue. Defaults to a current module name; :restart_delay - Defaults to 5000; :publishing_options - any valid options for AMQP.Basic.publish/5 except :reply_to, :correlation_id, :content_type - these will be set automatically and cannot be overridden. Defaults to []. Example usage with RMQ.Consumer Application 1: defmodule MyOtherApp.Consumer do use RMQ.Consumer, connection: MyOtherApp.RabbitConnection, queue: &quot;remote-resource-finder&quot; @impl RMQ.Consumer def consume(chan, payload, meta) do response = payload |&gt; Jason.decode!() |&gt; Map.fetch!(&quot;id&quot;) |&gt; MyOtherApp.Resource.get() |&gt; Jason.encode!() AMQP.Basic.publish(chan, meta.exchange, meta.reply_to, response, correlation_id: meta.correlation_id ) AMQP.Basic.ack(chan, meta.delivery_tag) end end Application 2: defmodule MyApp.RemoteResource do use RMQ.RPC, connection: MyApp.RabbitConnection, publishing_options: [app_id: &quot;MyApp&quot;] def find_by_id(id) do call(&quot;remote-resource-finder&quot;, %{id: id}) end end","ref":"RMQ.RPC.html","title":"RMQ.RPC","type":"behaviour"},{"doc":"Performs remote procedure call. options - same as publishing_options but have precedence over them. Can be omitted. timeout - same as timeout in configuration. Can be omitted.","ref":"RMQ.RPC.html#c:call/4","title":"RMQ.RPC.call/4","type":"callback"},{"doc":"Starts a GenServer process linked to the current process.","ref":"RMQ.RPC.html#c:start_link/1","title":"RMQ.RPC.start_link/1","type":"callback"},{"doc":"RMQ - RabbitMQ tools. A set of handy tools for working with RabbitMQ in Elixir projects. Based on amqp elixir client.","ref":"readme.html","title":"RMQ - RabbitMQ tools.","type":"extras"},{"doc":"The package can be installed by adding rmq to your list of dependencies in mix.exs: def deps do [ {:rmq, &quot;~&gt; 0.1.0-beta.0&quot;} ] end","ref":"readme.html#installation","title":"RMQ - RabbitMQ tools. - Installation","type":"extras"},{"doc":"A GenServer which opens and holds a connection to RabbitMQ broker. Usage defmodule MyApp.RabbitConnection do use RMQ.Connection, otp_app: :my_app, uri: &quot;amqp://localhost&quot;, connection_name: to_string(__MODULE__) end Meant to be started under the application&#39;s supervision tree as follows: defmodule MyApp.Application do use Application def start(_type, _args) do children = [ MyApp.RabbitConnection # ... ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end end Options :uri - AMQP URI (defaults to &quot;amqp://localhost&quot;); :connection_name - RabbitMQ connection name (defaults to :undefined); :reconnect_interval - Reconnect interval (defaults to 5000); options for AMQP.Connection.open/3. Options passed to start_link/1 will be merged into options from the config.","ref":"readme.html#rmq-connection","title":"RMQ - RabbitMQ tools. - RMQ.Connection","type":"extras"},{"doc":"RPC via RabbitMQ. Usage defmodule MyApp.RemoteResource do use RMQ.RPC, connection: MyApp.RabbitConnection, publishing_options: [app_id: &quot;MyApp&quot;] def find_by_id(id) do call(&quot;remote-resource-finder&quot;, %{id: id}, [message_id: &quot;msg-123&quot;]) end def list_all() do call(&quot;remote-resource-list-all&quot;, %{}) end end Options :connection - the connection module which implements RMQ.Connection behaviour; :exchange - the name of the exchange to which RPC consuming queue is bound. Please make sure the exchange exist. Defaults to &quot;&quot;. :timeout - default timeout for call/4 Defaults to 5000. :consumer_tag - consumer tag for the callback queue. Defaults to a current module name; :restart_delay - restart delay. Defaults to 5000; :publishing_options - options for AMQP.Basic.publish/5 except :reply_to, :correlation_id, :content_type - these will be set automatically and cannot be overridden. Defaults to [].","ref":"readme.html#rmq-rpc","title":"RMQ - RabbitMQ tools. - RMQ.RPC","type":"extras"},{"doc":"RabbitMQ Consumer. Usage defmodule MyApp.Consumer do use RMQ.Consumer, connection: MyApp.RabbitConnection, queue: &quot;my-app-consumer-queue&quot; @impl RMQ.Consumer def process(message, %{content_type: &quot;application/json&quot;}), do: Jason.decode!(message) def process(message, _meta), do: message @impl RMQ.Consumer def consume(chan, payload, meta) do # handle message here ack(chan, meta.delivery_tag) end end Options :connection - the connection module which implements RMQ.Connection behaviour; :queue - the name of the queue to consume. Will be created if does not exist; :exchange - the name of the exchange to which queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;&quot;; :routing_key - queue binding key. Defaults to queue; Will be created if does not exist. Defaults to &quot;&quot;; :dead_letter - defines if the consumer should setup deadletter exchange and queue. Defaults to true; :dead_letter_queue - the name of dead letter queue. Defaults to &quot;\#{queue}_error&quot;; :dead_letter_exchange - the name of the exchange to which dead_letter_queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;\#{exchange}.dead-letter&quot;; :dead_letter_routing_key - routing key for dead letter messages. Defaults to queue; :concurrency - defines if consume/3 callback will be called in a separate process using Task.start/1. Defaults to true; :prefetch_count - sets the message prefetch count. Defaults to 10; :consumer_tag - consumer tag. Defaults to a current module name; :restart_delay - restart delay. Defaults to 5000.","ref":"readme.html#rmq-consumer","title":"RMQ - RabbitMQ tools. - RMQ.Consumer","type":"extras"}]